
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Age_groupsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const age_groups = await db.age_groups.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        min_grade: data.min_grade
        ||
        null
            ,
            
        max_grade: data.max_grade
        ||
        null
            ,
            
        theme_scripture_reference: data.theme_scripture_reference
        ||
        null
            ,
            
        theme_scripture_text: data.theme_scripture_text
        ||
        null
            ,
            
        focus_summary: data.focus_summary
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return age_groups;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const age_groupsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                min_grade: item.min_grade
            ||
            null
            ,
            
                max_grade: item.max_grade
            ||
            null
            ,
            
                theme_scripture_reference: item.theme_scripture_reference
            ||
            null
            ,
            
                theme_scripture_text: item.theme_scripture_text
            ||
            null
            ,
            
                focus_summary: item.focus_summary
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const age_groups = await db.age_groups.bulkCreate(age_groupsData, { transaction });

        // For each item created, replace relation files
        

        return age_groups;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const age_groups = await db.age_groups.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.min_grade !== undefined) updatePayload.min_grade = data.min_grade;
        
        
        if (data.max_grade !== undefined) updatePayload.max_grade = data.max_grade;
        
        
        if (data.theme_scripture_reference !== undefined) updatePayload.theme_scripture_reference = data.theme_scripture_reference;
        
        
        if (data.theme_scripture_text !== undefined) updatePayload.theme_scripture_text = data.theme_scripture_text;
        
        
        if (data.focus_summary !== undefined) updatePayload.focus_summary = data.focus_summary;
        
        
        updatePayload.updatedById = currentUser.id;

        await age_groups.update(updatePayload, {transaction});

        
        

        
        

        

        return age_groups;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const age_groups = await db.age_groups.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of age_groups) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of age_groups) {
                await record.destroy({transaction});
            }
        });


        return age_groups;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const age_groups = await db.age_groups.findByPk(id, options);

        await age_groups.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await age_groups.destroy({
            transaction
        });

        return age_groups;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const age_groups = await db.age_groups.findOne(
            { where },
            { transaction },
        );

        if (!age_groups) {
            return age_groups;
        }

        const output = age_groups.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        output.enrollments_age_group = await age_groups.getEnrollments_age_group({
            transaction
        });
        
        
        
        
        
        
        output.field_trip_events_age_group = await age_groups.getField_trip_events_age_group({
            transaction
        });
        
        
        
        
        
        
        output.activity_blocks_age_group = await age_groups.getActivity_blocks_age_group({
            transaction
        });
        
        
        
        output.staff_assignments_age_group = await age_groups.getStaff_assignments_age_group({
            transaction
        });
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'age_groups',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.theme_scripture_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'age_groups',
                        'theme_scripture_reference',
                        filter.theme_scripture_reference,
                    ),
                };
            }
            
            if (filter.theme_scripture_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'age_groups',
                        'theme_scripture_text',
                        filter.theme_scripture_text,
                    ),
                };
            }
            
            if (filter.focus_summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'age_groups',
                        'focus_summary',
                        filter.focus_summary,
                    ),
                };
            }
            

            
            

            
            if (filter.min_gradeRange) {
                const [start, end] = filter.min_gradeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    min_grade: {
                    ...where.min_grade,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    min_grade: {
                    ...where.min_grade,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_gradeRange) {
                const [start, end] = filter.max_gradeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_grade: {
                    ...where.max_grade,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_grade: {
                    ...where.max_grade,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.age_groups.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'age_groups',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.age_groups.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

